using System;
using System.Collections.Generic;
using System.Text;

namespace Triangulator.Geometry
{
	/// <summary>
	/// 2D Point with double precision
	/// </summary>
	public class Point
	{
        public double[] x = new double[2];
        public double[] y = new double[2];
        public double Z0;

        public Boolean selected;


		/// <summary>
		/// Initializes a new instance of a point
		/// </summary>
		/// <param name="x"></param>
		/// <param name="y"></param>
        /*public Point(double x, double y)
        {
            x[0] = (int)x;
            y[0] = (int)y;
        }*/
        public Point(double x0, double y0, double x1, double y1)
        {
            x[0] = x0;
            y[0] = y0;

            x[1] = x1;
            y[1] = y1;
        }
        public Point(double x0, double y0, double z, double x1, double y1)
        {
            x[0] = x0;
            y[0] = y0;
            Z = z;
            x[1] = x1;
            y[1] = y1;
        }
        public Point(double x0, double y0, double z0)
        {
            X = x0;
            Y = y0;
            Z0 = z0;
         
        }
        public Point(double x0, double y0)
        {
            x[0] = x0;
            y[0] = y0;

            x[1] = x0;
            y[1] = y0;
        }
	
		/// <summary>
		/// Gets or sets the X component of the point
		/// </summary>
        public double X
        {
            get { return x[0]; }
            set { x[0] = value; }
        }
        /// <summary>
        /// Gets or sets the Y component of the point
        /// </summary>
        public double Y
        {
            get { return y[0]; }
            set { y[0] = value; }
        }

        /// <summary>
        /// Gets or sets the X component of the point
        /// </summary>
        public double X1
        {
            get { return x[1]; }
            set { x[1] = value; }
        }
        /// <summary>
        /// Gets or sets the Y component of the point
        /// </summary>
        public double Y1
        {
            get { return y[1]; }
            set { y[1] = value; }
        }

        /// <summary>
        /// Gets or sets the X1 component of the point
        /// </summary>
      

        /// <summary>
        /// Gets or sets the Z component of the point
        /// </summary>
        public double Z
        {
            get { return Z0; }
            set { Z0 = value; }
        }

        /// <summary>
		/// Makes a planar checks for if the points is spatially equal to another point.
		/// </summary>
		/// <param name="other">Point to check against</param>
		/// <returns>True if X and Y values are the same</returns>
		public bool Equals2D(Point other)
		{
			return (X == other.X && Y == other.Y);
		}
	}
}
